/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/
#include "kOptionsMenu.h"
/*#include "QDaemonApp.h"

extern void vibrate(int duration, int level);
extern void Debug( QString print);
extern QDaemonApp* a;

extern QString path;
extern QString skin_name;*/

kOptionsMenu::kOptionsMenu() : 
    QWidget(NULL, "kOptionsMenu")
	{
		//connect(app, SIGNAL(signalRaise()), this, SLOT(showMenu()));
		it_c=f_x=f_chx=0;f_xx=-1;f_c=10;
		
		//p_bg.load(path+skin_name+"/option_bg.png");
		//readConfig();
		
		up=down=launch=false;
		show_app=true;
		quit=false;
		click_anim=0;
		font=QFont(NULL, 15, 25, false);
		font_act=QFont(NULL, 15, 87, false);
		
		setBackgroundMode(NoBackground);
		resize(240, 320);
		
		bg_buf = new QPixmap(240, 320);
		
		timer = new QTimer(this);
		connect( timer, SIGNAL(timeout()), SLOT(keyBoardProcess()) );
		
		p.begin( bg_buf ,this);
		//set_paints();
		//QTimer::singleShot(100, this, SLOT(showMenu()));
	}
/*
kOptionsMenu::~kOptionsMenu()
	{
	}*/
	
void kOptionsMenu::showOptionMenu(int padding)
{
	if(cursor_h*h<height_t)
		height=cursor_h*h;
	else
		height=height_t;
	resize(width, height);
	move(0, 320-height-padding);//-soft_h
	set_paints();
	
	paint(0);
	show_app=true;
	show();
	
	if(anim_enable)
	{
		int x=-width;
		while(x<0)
		{
			x+=5;
			bitBlt( this, x, 0, bg_buf );
			qApp->processEvents();
		}
	}
	//app->slotRaise();
}

void kOptionsMenu::hideOptionMenu()
{
	f_x=0;f_c=10;f_xx=-1; 
	cur_it=h_vis_s=0;
	show_app=false;
	up=down=false;
	launch=false;
	timer->stop();
	hide();
}

void kOptionsMenu::runFunction()
{
	//QCopChannel::send(copWidget, optItem[cur_it].Func);
	emit select(optItem[cur_it].Func);
	hideOptionMenu();
}

void kOptionsMenu::addItem(QString name, QString func,/* QString icon,*/ int type)
{
	option_item tmp;
	tmp.Name=name;
	tmp.Func=func;
	/*if(!icon.isNull())
		tmp.Icon=QPixmap(icon);*/
	tmp.Type=type;
	
	optItem.push_back(tmp);
	//Debug(optItem[it_c].Name+QString(" %1").arg(it_c));
	it_c++;
	
	set_paints();
}
void kOptionsMenu::changeItem(int id, QString name, QString func,/* QString icon,*/ int type)
{
	if(!name.isNull())
		optItem[id].Name=name;
	if(!func.isNull())
		optItem[id].Func=func;
	/*if(!icon.isNull())
		optItem[id].Icon=QPixmap(icon);*/
	if(type!=0)
		optItem[id].Type=type;
}
void kOptionsMenu::delItem(int id)
{
	//optItem.deleteItem(id);
	set_paints();
}
void kOptionsMenu::clear()
{
	optItem.clear();
	it_c=0;
}
	
void kOptionsMenu::set_paints()
	{
		scroll_w=sb_w+2;
		
		cur_it=0;
		h_vis=(height)/(cursor_h);
		h_vis_s=h_vis_change=0;
		
		h=it_c;//optItem.count();
		scrollsize=h_vis*(height)/h;
		
		drawCursor();
	}
	
void kOptionsMenu::drawCursor()
{
	QPainter ptmp;
	ptmp.begin( &cursor ,this);
	ptmp.setPen(cursorCol);
	ptmp.fillRect(0, 0, width, cursor_h, QBrush(cursorCol));
	if(cursor3d)
	{
		int r=cursorCol.red();int g=cursorCol.green();int b=cursorCol.blue();
		r+=40;g+=40;b+=40;
		if(r>255)r=255;if(g>255)g=255;if(b>255)b=255;
		ptmp.setPen(QColor(r,g,b));
		ptmp.drawLine(0, 0, width, 0);
		r=cursorCol.red();g=cursorCol.green();b=cursorCol.blue();
		for(int i=cursor_h/2;i<cursor_h;i++)
		{
			r-=5;g-=5;b-=5;
			if(r<0)r=0;if(g<0)g=0;if(b<0)b=0;
			ptmp.setPen(QColor(r,g,b));
			ptmp.drawLine(0, i, width, i);
		}
	}
	ptmp.end();
}

void kOptionsMenu::paint(int anim)
	{
		int y_anim=0, y_anim_c=0, y_anim_i=0, d=1, anim_step=0;
	
		if(anim)
		{
			if(up) {d=1;}
			if(down) {d=-1;}
			anim_step=cursor_h/(anim+1);
			
			y_anim=cursor_h-anim_step;
		}
		do
		{
			///anim_obj_set
			if(h_vis_change==h_vis_s)
			{
				y_anim_c=y_anim;
				y_anim_i=0;
			}
			else
			{
				y_anim_i=y_anim;
				y_anim_c=0;
			}
			
			///bg
			
			//p.drawPixmap(0, 0, p_bg);
			p.setPen(bgBorderColor);
			p.setBrush(bgColor);
			p.drawRect(0, 0, width, height);
			
			///cursor
			int cur_y=cursor_h*(cur_it-h_vis_s)+y_anim_c*d;
			p.drawPixmap(1, cur_y, cursor);
			//p.fillRect(1, cur_y, width, cursor_h, QBrush(sbCol));
			
			/// Items
			int anim_line_down=0;
			if(down && h_vis_s>0)
				anim_line_down=-1;
			for(int j=h_vis_s+anim_line_down; j<(h_vis+h_vis_s+1); j++)
			{
				if(j>=h || quit)
					break;
				int y=cursor_h*(j-h_vis_s)+y_anim_i*(-d);
				//p.drawPixmap(x+c, y+c, optItem[j].Icon);
				
				int f_f=nameSize-2+(cursor_h-nameSize)/2;
				p.setPen(nameCol);
				QFont f;
				f=font;
				int x=0;
				if(j==cur_it)
				{
					p.setPen(nameCol_act);
					if(launch)
						f=font_act;
					QFontMetrics fm(f);
					int leight_name=fm.width(optItem[j].Name);
					if(leight_name>width)
					{
						f_chx=leight_name;
						x=f_x;
					}
					else
						f_chx=0;
				}
				if(optItem[j].Type==1 || optItem[j].Type==-1)
				{
					p.setPen(nameCol_unact);
					f=font;
				}
				p.setFont(f);
				
				//Debug("paint "+optItem[j].Name+QString(" ::ok").arg(y));
				//
				//if(leight_name>width)
				p.drawText(5+x, y+f_f, optItem[j].Name, -1);
			}
			
			///scroll
			int s_size=h-h_vis;	if(s_size<1)s_size=1;
			int scroll=h_vis_change*(height-2-scrollsize)/(s_size);
			
			p.setPen(sbsCol);
			p.drawRect(width-(sb_w+2), 0, sb_w+2, height);
			p.setPen(sbCol);
			p.fillRect(width-(sb_w+1), 1+scroll, sb_w, scrollsize, QBrush(sbCol));
			
			///
			repaint();
			
			///anim_check
			anim--;
			if(anim<=0)
			{
				y_anim=0;
				h_vis_change=h_vis_s;
			}
			else
			{
				y_anim=y_anim-anim_step;
			}
			delay(anim_delay);
		}
		while(anim>=0 && !quit);
	}

void kOptionsMenu::repaint()
	{
		bitBlt( this, 0, 0, bg_buf );
		//Debug(QString("kOptionsMenu::repaint"));
	}

void kOptionsMenu::keyBoardProcess()
{
	qApp->processEvents();
	
	if(up)		cur_it=(cur_it+h-1)%h;
	if(down)	cur_it=(++cur_it)%h;

	if(up||down)
	{
		f_x=0;f_c=10;f_xx=-1;
		
		if(cur_it<0)cur_it=0;
		while(optItem[cur_it].Type==-1)
		{
			if(up)	cur_it=(cur_it+h-1)%h;
			if(down)	cur_it=(++cur_it)%h;
			if(cur_it<0)cur_it=0;
		}
		
		h_vis_s=(cur_it+1)-h_vis;
		if(h_vis_s<0)h_vis_s=0;
		/*
		if(!down && h_vis_s!=0 && cur_j!=h-1)
		{
			if((h_vis-h_vis_s)!=cur_j)h_vis_s=h_vis_change;
		}*/
		paint(animation);
	}
	
	if(f_chx)
	{
		if(f_c>0)
			f_c--;
		else
		{
			f_x=f_x+f_xx;
			if(f_chx+f_x<=width-12 || f_x>=2)
				f_xx=-f_xx;
			paint(0);
		}
	}
}

void kOptionsMenu::keyPressEvent(QKeyEvent *event)
	{
		//printf("KEY: %x\n", event->key());
		switch (event->key())
		{
			case 0x1004: //	Center
				if(!launch && optItem[cur_it].Type!=1)
				{
					launch=true;
					paint(0);
				}
			break;
			
			case 0x1014: //	Right
				if(!launch && optItem[cur_it].Type!=1)
				{
					launch=true;
					paint(0);
				}
			break;
			case 0x1012: //	Left
				hideOptionMenu();
			break;
			case 0x1013: //	Up
				up=true;
			break;
			case 0x1015: //	Down
				down=true;
			break;
			
			case 0x1031: //	Red
				hideOptionMenu();
			break;
			
			case 0x103a: //	RightSoft
				hideOptionMenu();
			break;
			
			case 0x1032: //	c
				hideOptionMenu();
			break;
			
			case 0x1016: //	VolumeUp
				up=true;
			break;
			case 0x1017: //	VolumeDown
				down=true;
			break;
			
			case 48:
			break;
			
			case 42://	*
				anim_enable=!anim_enable;
				animEnable();
			break;
			
			default:
			break;
		}
	}
	
void kOptionsMenu::keyReleaseEvent(QKeyEvent *event)
	{
		switch (event->key())
		{
			case 0x1004:
				if(launch)
				{
					launch=false;
					runFunction();
					paint(0);
				}
			break;
			
			case 0x1014: //	Right
				if(launch)
				{
					launch=false;
					runFunction();
					paint(0);
				}
			break;
			
			case 0x1013: //	Up
				if(!vibro_type)
					///vibrate(vibr_duration, vibr_level);
				up=false;
			break;
			case 0x1015: //	Down
				if(!vibro_type)
					///vibrate(vibr_duration, vibr_level);
				down=false;
			break;
			
			case 0x1016: //	VolumeUp
				if(!vibro_type)
					///vibrate(vibr_duration, vibr_level);
				up=false;
			break;
			case 0x1017: //	VolumeDown
				if(!vibro_type)
					///vibrate(vibr_duration, vibr_level);
				down=false;
			break;
			
			default:
			break;
		}
	}


void kOptionsMenu::animEnable()
{
	if(anim_enable)
	{
		animation=animation_t;
		anim_delay=anim_delay_t;
		anim_key_delay=anim_key_delay_t;
	}
	else
	{
		animation=0;
		anim_delay=0;
		anim_key_delay=120;
	}
	ZConfig cfg(/**path+skin_name+*/"/Options.ini", true);
	cfg.writeEntry(QString("Setting"), QString("AnimationEnable"), QString("%1").arg(anim_enable));
	cfg.flush();
}

void kOptionsMenu::readSkinCfg()
	{
		//int tmp=0;
		//QString col="";
		
		//cursor_h=26;//skin
		//cursor3d=1;//skin
		//sbsCol=QColor(0,0,0);//skin
		//sbCol=QColor(0,140,250);//skin
		//sb_w=2;//skin
		//nameCol=QColor(240,240,240);//skin
		//nameCol_act=QColor(250,250,250);//skin
		//nameCol_unact=QColor(160,160,160);//skin
		//nameSize=15;//skin
		//anim_enable=1;//skin
		//animation=5;//skin
		//anim_delay=0;//skin
		//anim_key_delay=80;//skin
		//width=180;height=200;//skin
		
		ZConfig cfg(/**path+skin_name+*/"/Options.ini", true);
		
		width=atoi(cfg.readEntry(QString("BgSetting"),		QString("Width"), "180"));
		height=height_t=atoi(cfg.readEntry(QString("BgSetting"),QString("Height"), "200"));
		bgColor=cfg.readEntry(QString("BgSetting"),			QString("Color"), "#333333");
		bgBorderColor=cfg.readEntry(QString("BgSetting"),	QString("BorderColor"), "#555555");
		
		anim_enable=atoi(cfg.readEntry(QString("Setting"),	QString("AnimationEnable"), "1"));
		animation_t=atoi(cfg.readEntry(QString("Setting"),	QString("Animation"), "2"));
		if(animation_t<1)animation_t=1;
		anim_delay_t=atoi(cfg.readEntry(QString("Setting"),	QString("AnimationDelay"), "1"));
		if(anim_delay_t<1)anim_delay_t=1;
		anim_key_delay_t=atoi(cfg.readEntry(QString("Setting"), QString("AnimationKeyDelay"), "100"));
		if(anim_key_delay_t<1)anim_key_delay_t=100;
		vibro_type=atoi(cfg.readEntry(QString("Setting"),	 QString("VibrateType"), "0"));
		if(vibro_type<0)vibro_type=0;
		vibr_duration=atoi(cfg.readEntry(QString("Setting"), QString("VibrateDuration"), "0"));
		if(vibr_duration<0)vibr_duration=0;
		vibr_level=atoi(cfg.readEntry(QString("Setting"),	QString("VibrateLevel"), "0"));
		if(vibr_level<0)vibr_level=0;if(vibr_level>3)vibr_level=3;
		vibr_launch_duration=atoi(cfg.readEntry(QString("Setting"),	QString("VibrateLaunchDuration"), "0"));
		if(vibr_launch_duration<0)vibr_launch_duration=0;
		vibr_launch_level=atoi(cfg.readEntry(QString("Setting"),	QString("VibrateLaunchLevel"), "0"));
		if(vibr_launch_level<0)vibr_launch_level=0;if(vibr_launch_level>3)vibr_launch_level=3;
		
		sbsCol=cfg.readEntry(QString("ScrollBar"),		QString("BgColor"), "#000000");
		sbCol=cfg.readEntry(QString("ScrollBar"),		QString("Color"), "#ffffff");
		sb_w=atoi(cfg.readEntry(QString("ScrollBar"),	QString("ScrollWidth"), "1"));

		cursor_h=atoi(cfg.readEntry(QString("Cursor"),	QString("Height"), "26"));
		cursorCol=cfg.readEntry(QString("Cursor"),		QString("Color"), "#ffffff");
		cursor3d=atoi(cfg.readEntry(QString("Cursor"),	QString("3dColor"), "0"));
		
		nameSize=atoi(cfg.readEntry(QString("FontIconName"),	QString("Size"), "15"));
		nameCol=cfg.readEntry(QString("FontIconName"),			QString("Color"), "#cccccc");
		nameCol_act=cfg.readEntry(QString("FontIconName"),		QString("ActiveColor"), "#ffffff");
		nameCol_unact=cfg.readEntry(QString("FontIconName"),	QString("UnActiveColor"), "#888888");
		
		cfg.flush();
		
		font.setPixelSize(nameSize);
		font_act.setPixelSize(nameSize);
		
		cursor=QPixmap(width, cursor_h);
		//bg_buf->resize(width, height);
		//qDebug("opt resize ok");
		
		animEnable();
		//set_paints();
	}
	
void kOptionsMenu::focusOutEvent(QFocusEvent *)
{
	///Debug("Options out focus");
	//timer->stop();
	hideOptionMenu();
}

void kOptionsMenu::focusInEvent(QFocusEvent *)
{
	///Debug("Options in focus");
	timer->start(anim_key_delay);
	QTimer::singleShot(100, this, SLOT(repaint()));
	//showMenu();
}

void kOptionsMenu::delay(int msec)
{
	struct timespec elapsed, tv;
	elapsed.tv_sec = msec/1000;
	elapsed.tv_nsec = (msec%1000)*1000000;
	tv.tv_sec = elapsed.tv_sec;
	tv.tv_nsec = elapsed.tv_nsec;
	nanosleep(&tv, &elapsed);
}
