/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/

#include <QWidget.h>
#include <ZLineEdit.h>
#include <qcopchannel_qws.h>
#include <ZConfig.h>
#include <qpainter.h>
#include <qtimer.h>
#include <vector>

//#include "kOptionsMenu.h"

class kShowDlg : public QWidget
{
    Q_OBJECT

public:
    kShowDlg();
    //~kShowDlg();
	
	QPainter		p;
	QPixmap* 		bg_buf;
	ZLineEdit*		line;
	//kOptionsMenu*	menu;
	//QCopChannel* 	cop_menu;

	QColor		bgCol, bgBrushCol;
	QColor		bgTitleCol, bgBrushTitleCol;
	QColor		titleCol,title_warnCol;
	QColor		textCol;
	QColor		softLineCol, softLine_actCol;
	QColor		softBgCol, softBg_actCol;
	QColor		softCol, soft_actCol;
	int			titleHeight, titleSize;
	int			textSize, borderSize;
	int			editHeight, editSize;
	int			softHeight, softSize;
	
	QFont	titleFont;
	QFont	textFont;
	//QFont	editFont;
	QFont	softFont;

	bool show_app, edit_line;
	
	int width, height, line_h, padding;
	int x;
	
	QString Title;
	QStringList Text;
	QString leftSoft, rightSoft;
	bool lsoft,rsoft;
	bool warning;
	
	int vibr_duration, vibr_level;
	
	bool question, reply;

	bool Show(QString title, QString text, QString edittext);
	bool Show(QString title, QString text, int type);
	QString getText(){return line->text();}
	
	void initSoftKey(QString lSoft, QString rSoft);
	
	void setText(QString str);

	void paint();
	void readSkinCfg();
	
	void keyPressEvent(QKeyEvent *event);
	void keyReleaseEvent(QKeyEvent *event);
	void focusOutEvent(QFocusEvent* event);
	void focusInEvent(QFocusEvent* event);
	
public slots:
	void repaint();
	void showLine();
	//void optionFunction(const QCString&);
};
